/*
  DCF
  SETA43 1/10/2024
  seta43.duckdns.org
  seta43.blogspot.com
*/

//#define MODO_AUDIO 

#define MOD_DCF   2
#define OUT_DCF   3
#define LED_TEST   13

#define TIME_0 100
#define TIME_1 200

char clave[] = "DCFSETA";

#define TAMANO 20
char entrada[TAMANO];
boolean stringComplete = false;
int contador;

unsigned char dataDCF[60];
char cadena[80];
char buffer[TAMANO];
int valor;

unsigned char hora,minuto,diaMes,diaSemana,mes;
int ano;

unsigned long tiempo,tiempoOld;
char segundo;

boolean playDCF = false;
int z;

void setup() 
{
    Serial.begin(9600);
    pinMode(LED_TEST, OUTPUT);   
    pinMode(OUT_DCF, OUTPUT);
    pinMode(MOD_DCF, OUTPUT);

    Serial.print("Empieza DCF SETA");
    #ifdef MODO_AUDIO
      Serial.println(" ->AUDIO");
   #else
      Serial.println(" ->RF");
   #endif
   
    for (char zx = 0; zx < 3; zx++) { Serial.println(clave); delay(200); } 
    
  
   #ifdef MODO_AUDIO
    frecuSET(64); //Divisor por 8 -- (1000000/15500)-1=64 -->15384 Hz
   #else
    frecuSET(102);  // 77,5KHz  x=(8000000/77,50)-1=102 ->77,76khz
   #endif
   frecuON();
   segundo=50; hora=4;minuto=43,diaMes=25,diaSemana=3,mes=9; ano=2024;
   setDatos();
}



void loop() 
{
  delay(1);

 while (Serial.available())
    {
      char inChar = (char)Serial.read();
      entrada[contador] = inChar;
      if (inChar == 13 || inChar == 10)
        {
          stringComplete = true;
          entrada[contador] = 0;
        }
      if(contador<TAMANO-1) contador++;
    }

  if (stringComplete)
    {
     contador = 0;
     stringComplete = false;
     for(z=0;z<TAMANO;z++) if(entrada[z]>96 && entrada[z]<123) entrada[z]-=32;  //minúsculas a mayusculas

     Orden(entrada);
    }

  tiempo=millis();
  if(tiempo-tiempoOld>1000 && playDCF==true)
    {
      tiempoOld=tiempo;
      modularDCF();
    }
}


void modularDCF(void)
{
    if(segundo!=59)
            {
              while(0==digitalRead(OUT_DCF)); //Sincroniza datos con flanco de bajada portadora
              while(1==digitalRead(OUT_DCF));

              #ifdef MODO_AUDIO
               frecuOFF(); 
             #else
               digitalWrite(LED_TEST, LOW);   
               digitalWrite(MOD_DCF, LOW);
             #endif 
            
              if(dataDCF[segundo]==0) 
                  {  delay(TIME_0);  Serial.print("0");  }
                else
                  {  delay(TIME_1);  Serial.print("1");  }

             #ifdef MODO_AUDIO
               frecuON();
             #else
               digitalWrite(LED_TEST, HIGH);
               digitalWrite(MOD_DCF, HIGH); 
             #endif 
    
              if (segundo==14 || segundo==20 || segundo==27 || segundo==28 || segundo==35 || segundo==34 || segundo==41 || segundo==44 || segundo==49  || segundo==57 || segundo==58) Serial.print("_");
            }
            else
            {
              ;
            }
      segundo++; 
      if(segundo>59)
        {
          segundo=0; minuto++;
          if(minuto>59) {minuto=0;hora++;if(hora>23)hora=0; } //No funciona con cambio de fecha
          setDatos();
          printDatos();
          tiempoOld+=100;
        }
}




void Orden(char *bufferS)
{ 
      runFuniones();
}  

void runFuniones(void)
{
  if(strstr(entrada,clave) )
      {
        Serial.println("OK");
        goto salir0;
      }
  if(!strncmp(entrada,"HORA=",5))
    {   
      Serial.print("#HORA=");
      strcpy(buffer,entrada+5);
      valor=atoi(buffer); 
      Serial.println(valor);  
      hora=valor;
      goto salir0;
    }
 if(!strncmp(entrada,"SEGUNDO=",8))
    {   
      Serial.print("#SEGUNDO=");
      strcpy(buffer,entrada+8);
      valor=atoi(buffer); 
      Serial.println(valor);  
      segundo=valor;
      goto salir0;
    }
    
  if(!strncmp(entrada,"MINUTO=",7))
    {   
      Serial.print("#MINUTO=");
      strcpy(buffer,entrada+7);
      valor=atoi(buffer); 
      Serial.println(valor);  
      minuto=valor;
      goto salir0;
    }
 if(!strncmp(entrada,"DIAMES=",7))
    {   
      Serial.print("#DIAMES=");
      strcpy(buffer,entrada+7);
      valor=atoi(buffer); 
      Serial.println(valor);  
      diaMes=valor;
      goto salir0;
    }
 if(!strncmp(entrada,"DIASEMANA=",10))
    {   
      Serial.print("#DIASEMANA=");
      strcpy(buffer,entrada+10);
      valor=atoi(buffer); 
      Serial.println(valor);  
      diaSemana=valor;
      goto salir0;
    }
 if(!strncmp(entrada,"MES=",4))
    {   
      Serial.print("#MES=");
      strcpy(buffer,entrada+4);
      valor=atoi(buffer); 
      Serial.println(valor);  
      mes=valor;
      goto salir0;
    }
  if(!strncmp(entrada,"ANO=",4))
    {   
      Serial.print("#AÑO=");
      strcpy(buffer,entrada+4);
      valor=atoi(buffer); 
      Serial.println(valor);  
      ano=valor;
      goto salir0;
    }
  if(!strncmp(entrada,"PRINT",5))
    {   
      printDatos();
      goto salir0;
    }
 if(!strncmp(entrada,"START",5))
    { 
      Serial.print("#PLAY segundo="); Serial.println(segundo);
      minuto++;
      if(minuto>59) {minuto=0;hora++;if(hora>23)hora=0; } //No funciona con cambio de fecha 
      setDatos();
      playDCF=true;
      goto salir0;
    }
 if(!strncmp(entrada,"STOP",4))
    { 
      Serial.print("#STOP");  
      playDCF=false;
      goto salir0;
    }
  Serial.println("aERROR ");
salir0:
 ;
}      





void printDatos(void)
{ 
  setDatos();
    Serial.println("");
    sprintf(cadena,"#### %02d:%02d %02d-%02d-%04d %02d",hora,minuto,diaMes,mes,ano,diaSemana);
    Serial.println(cadena);
    sprintf(cadena,"000000000000000 EASNL1 mmmmmmm p hhhhhh p dddddd www mmmmm yyyyyyyy p");
    Serial.println(cadena);
    
    for(int z=0;z<59;z++)
    {
        Serial.print(dataDCF[z]);
        if (z==14 || z==20 || z==27 || z==28 || z==35 || z==34 || z==41 || z==44 || z==49  || z==57 || z==58) Serial.print(" ");
    }
   Serial.println(""); 
}




void setDatos(void)
{
 char p;
 clearDatos();
    dataDCF[17]=1; //Verano
    dataDCF[20]=1; //Start
    dcfMinuto();
    dcfHora();
    dcfDiaMes();
    dcfDiaSemana();
    dcfMes();
    dcfAno();
    //bit 58 paridad desde el bit 36 al bit 57
    for(char z=36;z<58;z++) p+=dataDCF[z];
    dataDCF[58]=p&1;
}



//_______FRECU______

void frecuSET(unsigned char f)
{
  //___________Contador 2___________ PIN3_________________

  // Clear Timer on Compare Match (CTC) Mode
  bitWrite(TCCR2A, WGM20, 0);
  bitWrite(TCCR2A, WGM21, 1);
  bitWrite(TCCR2B, WGM22, 0);
  //  bitWrite(TCCR2B, WGM23, 0);

  // Toggle OC1A and OC1B on Compare Match.
  bitWrite(TCCR2A, COM2A0, 1);
  bitWrite(TCCR2A, COM2A1, 0);
  bitWrite(TCCR2A, COM2B0, 1);
  bitWrite(TCCR2A, COM2B1, 0);

  // prescaling
  #ifdef MODO_AUDIO
    bitWrite(TCCR2B, CS20, 0);   //sin divisor
    bitWrite(TCCR2B, CS21, 1);  // divisor por 8
   #else
    bitWrite(TCCR2B, CS20, 1);   //sin divisor
    bitWrite(TCCR2B, CS21, 0);  // divisor por 8
   #endif 
  bitWrite(TCCR2B, CS22, 0);

  OCR2A = f;
  OCR2B = f;

}

void frecuON(void)
{
  bitWrite(TCCR2A, COM2A0, 1);
  bitWrite(TCCR2A, COM2B0, 1);
}

void frecuOFF(void)
{
  bitWrite(TCCR2A, COM2A0, 0);
  bitWrite(TCCR2A, COM2B0, 0);
}



void clearDatos(void)
{
    for(int z=0;z<60;z++)dataDCF[z]=0;
}

void dcfMinuto()
{
 int tmp=minuto;
  char p=0;
    if(tmp>=40) { dataDCF[27]=1; tmp-=40; p++;}
    if(tmp>=20) { dataDCF[26]=1; tmp-=20; p++;}
    if(tmp>=10) { dataDCF[25]=1; tmp-=10; p++;}
    if(tmp>=8) { dataDCF[24]=1; tmp-=8; p++;}
    if(tmp>=4) { dataDCF[23]=1; tmp-=4; p++;}
    if(tmp>=2) { dataDCF[22]=1; tmp-=2; p++;}
    if(tmp>=1) { dataDCF[21]=1; tmp-=1; p++;}
    if(p&1) dataDCF[28]=1;
}

void dcfHora()
{
 int tmp=hora;
 char p=0;
    if(tmp>=20) { dataDCF[34]=1; tmp-=20; p++;}
    if(tmp>=10) { dataDCF[33]=1; tmp-=10; p++;}
    if(tmp>=8) { dataDCF[32]=1; tmp-=8; p++;}
    if(tmp>=4) { dataDCF[31]=1; tmp-=4; p++;}
    if(tmp>=2) { dataDCF[30]=1; tmp-=2; p++;}
    if(tmp>=1) { dataDCF[29]=1; tmp-=1; p++;}
    if(p&1) dataDCF[35]=1;
}

void dcfDiaMes()
{
int tmp=diaMes;
    if(tmp>=20) { dataDCF[41]=1; tmp-=20;}
    if(tmp>=10) { dataDCF[40]=1; tmp-=10;}
    if(tmp>=8) { dataDCF[39]=1; tmp-=8;}
    if(tmp>=4) { dataDCF[38]=1; tmp-=4;}
    if(tmp>=2) { dataDCF[37]=1; tmp-=2;}
    if(tmp>=1) { dataDCF[36]=1; tmp-=1;}
}
void dcfDiaSemana()
{
int tmp=diaSemana;
    if(tmp>=4) { dataDCF[44]=1; tmp-=4;}
    if(tmp>=2) { dataDCF[43]=1; tmp-=2;}
    if(tmp>=1) { dataDCF[42]=1; tmp-=1;}
}
void dcfMes()
{
int tmp=mes;
    if(tmp>=10) { dataDCF[49]=1; tmp-=10;}
    if(tmp>=8) { dataDCF[48]=1; tmp-=8;}
    if(tmp>=4) { dataDCF[47]=1; tmp-=4;}
    if(tmp>=2) { dataDCF[46]=1; tmp-=2;}
    if(tmp>=1) { dataDCF[45]=1; tmp-=1;}
}
void dcfAno()
{
int tmp=ano-2000;
    if(tmp>=80) { dataDCF[57]=1; tmp-=80;}
    if(tmp>=40) { dataDCF[56]=1; tmp-=40;}
    if(tmp>=20) { dataDCF[55]=1; tmp-=20;}
    if(tmp>=10) { dataDCF[54]=1; tmp-=10;}
    if(tmp>=8) { dataDCF[53]=1; tmp-=8;}
    if(tmp>=4) { dataDCF[52]=1; tmp-=4;}
    if(tmp>=2) { dataDCF[51]=1; tmp-=2;}
    if(tmp>=1) { dataDCF[50]=1; tmp-=1;}

}
